## spectrum2 2.2.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
# Use test target on CMake 3.11+
cmake_policy(SET CMP0037 OLD)

project(libtransport)

set(CMAKE_CXX_STANDARD 11)
if(WIN32)
	set(CMAKE_CXX_STANDARD 17)
endif(WIN32)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(GNUInstallDirs)

include(CPack)
message(STATUS "Variables to override default places where to find libraries:")
message(STATUS "|- cppunit : -DCPPUNIT_INCLUDE_DIR,  -DCPPUNIT_LIBRARY")
message(STATUS "|- swiften : -DSWIFTEN_INCLUDE_DIR,  -DSWIFTEN_LIBRARY")
message(STATUS "  |- zlib  :                         -DZLIB_LIBRARY")
message(STATUS "  |- expat :                         -DEXPAT_LIBRARY")
message(STATUS "  |-libidn :                         -DLIBIDN_LIBRARY")
message(STATUS "  |-libxml :                         -DLIBXML_LIBRARY")
message(STATUS "|- boost   : -DBOOST_INCLUDEDIR,     -DBOOST_LIBRARYDIR")
message(STATUS "|- protobuf: -DPROTOBUF_INCLUDE_DIR, -DPROTOBUF_LIBRARY")
message(STATUS "           : -DPROTOBUF_PROTOC_EXECUTABLE")
message(STATUS "|- log4cxx : -DLOG4CXX_INCLUDE_DIR,  -DLOG4CXX_LIBRARIES")
message(STATUS "|- purple  : -DPURPLE_INCLUDE_DIR,   -DPURPLE_LIBRARY")
message(STATUS "           : -DPURPLE_NOT_RUNTIME - enables compilation with libpurple.lib")
message(STATUS "|- pgxx    : -DPQXX_INCLUDE_DIR,     -DPQXX_LIBRARY")
message(STATUS "|- irc     : -DIRC_INCLUDE_DIR,      -DIRC_LIBRARY")

option(ENABLE_SQLITE3 "Build with SQLite3 support" ON)
option(ENABLE_MYSQL "Build with MySQL support" ON)
option(ENABLE_PQXX "Build with Postgres supoort" ON)

option(ENABLE_FROTZ "Build Frotz plugin" ON)
option(ENABLE_IRC "Build IRC plugin" ON)
option(ENABLE_PURPLE "Build Libpurple plugin" ON)
option(ENABLE_SMSTOOLS3 "Build SMSTools3 plugin" ON)
option(ENABLE_XMPP "Build XMPP plugin" ON)
option(ENABLE_TWITTER "Build Twitter plugin" ON)
option(ENABLE_WEBUI "Build Web UI" ON)

option(ENABLE_DOCS "Build Docs" ON)
# option(ENABLE_LOG "Build with logging using Log4cxx" ON)
option(ENABLE_TESTS "Build Tests using CppUnit" OFF)

macro(LIST_CONTAINS var value)
	set(${var})
	foreach(value2 ${ARGN})
		if(${value} STREQUAL ${value2})
			set(${var} TRUE)
		endif(${value} STREQUAL ${value2})
	endforeach(value2)
endmacro(LIST_CONTAINS)

if(NOT LIB_INSTALL_DIR)
	set(LIB_INSTALL_DIR "lib")
endif()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules")

###### Prerequisites ######

# FIND SWIFTEN

find_package(Swiften)

if(NOT SWIFTEN_FOUND)
	if(ZLIB_LIBRARY)
		set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} ${ZLIB_LIBRARY})
	endif()
	if(EXPAT_LIBRARY)
		set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} ${EXPAT_LIBRARY})
	endif()
	if(LIBIDN_LIBRARY)
		set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} ${LIBIDN_LIBRARY})
	endif()
	if(LIBXML_LIBRARY)
		set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} ${LIBXML_LIBRARY})
	endif()
	
	set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} "Dnsapi")
	set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} "Crypt32")
	set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} "Secur32")
	set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} "Iphlpapi")
	set(SWIFTEN_LIBRARY ${SWIFTEN_LIBRARY} "Winscard")
	message(STATUS "Using swiften: ${SWIFTEN_INCLUDE_DIR} ${SWIFTEN_LIBRARY}")
endif()

# FIND BOOST
if(WIN32)
	set(Boost_USE_STATIC_LIBS      OFF)
	set(Boost_USE_MULTITHREADED      ON)
	set(Boost_USE_STATIC_RUNTIME    OFF)
	add_definitions(-DBOOST_ALL_DYN_LINK)
	add_definitions(-DBOOST_ALL_NO_LIB)
	link_directories("$ENV{CMAKE_PREFIX_PATH}/lib")
endif(WIN32)

set(Boost_FIND_QUIETLY ON)
find_package(Boost COMPONENTS program_options date_time system filesystem regex thread locale REQUIRED)

message( STATUS "Found Boost: ${Boost_VERSION}, ${Boost_LIBRARIES}, ${Boost_INCLUDE_DIR}")

if(${Boost_VERSION} GREATER 104999)
	message( STATUS "Using BOOST_FILESYSTEM_VERSION=3")
	add_definitions(-DBOOST_FILESYSTEM_VERSION=3)
endif()
add_definitions(-DBOOST_BIND_GLOBAL_PLACEHOLDERS)

# FIND POPT
if(NOT WIN32)
	find_package(popt REQUIRED)
endif()

###### Database ######

# FIND SQLITE3
if(ENABLE_SQLITE3)
	find_package(sqlite3)
endif()

# FIND MYSQL
if(ENABLE_MYSQL)
	find_package(mysql)
endif()

# FIND PQXX
if(ENABLE_PQXX)
	find_package(pqxx)
endif()

###### Plugins ######

# FIND LIBPURPLE
if(ENABLE_PURPLE)
	find_package(purple)

	if(WIN32)
		if(PURPLE_NOT_RUNTIME)
			add_definitions(-DPURPLE_RUNTIME=0)
		else(PURPLE_NOT_RUNTIME)
			add_definitions(-DPURPLE_RUNTIME=1)
		endif(PURPLE_NOT_RUNTIME)
	else()
		add_definitions(-DPURPLE_RUNTIME=0)
	endif()

	# FIND LIBEVENT
	find_package(event)
endif()

# FIND GLIB
if(ENABLE_PURPLE)
		find_package(GLIB2)
endif()

# FIND LIBXML2
# find_package(libxml2)

# FIND PROTOBUF
find_package(PROTOBUF REQUIRED)

if(NOT PROTOBUF_FOUND AND PROTOBUF_INCLUDE_DIR AND PROTOBUF_LIBRARY)
	set(PROTOBUF_FOUND 1)
	set(PROTOBUF_INCLUDE_DIRS ${PROTOBUF_INCLUDE_DIR})
	if(PROTOBUF_PROTOC_EXECUTABLE)
	else()
		set(PROTOBUF_PROTOC_EXECUTABLE protoc)
	endif()
	message(STATUS "Using protobuf: ${PROTOBUF_INCLUDE_DIRS} ${PROTOBUF_LIBRARY}")
endif()

find_package(JsonCpp REQUIRED)

if(WIN32)
	add_definitions(-DSWIFTEN_STATIC=1)
	add_definitions(-D_WIN32_WINNT=0x0600)
	add_definitions(-DWIN32_LEAN_AND_MEAN)
	add_definitions(-DBOOST_USE_WINDOWS_H)
	add_definitions(-D_UNICODE)
	add_definitions(-DUNICODE)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
	find_package(openssl)
endif()

add_definitions(-DSUPPORT_LEGACY_CAPS)

if(ENABLE_IRC)
	find_package(Communi)
	find_package(Qt5 COMPONENTS Core Network)
endif()

find_package(event)

####### Miscallanous ######

if(ENABLE_DOCS)
	find_package(Doxygen)
endif()

set(log4cxx_DIR "${CMAKE_SOURCE_DIR}/cmake_modules")
find_package(log4cxx)

# FIND CPPUNIT
if(ENABLE_TESTS)
	find_package(CppUnit)

	if(NOT CPPUNIT_FOUND AND CPPUNIT_INCLUDE_DIR AND CPPUNIT_LIBRARY)
		set(CCPUNIT_LIBRARIES ${CPPUNIT_LIBRARY})
		set(CPPUNIT_FOUND 1)
		message(STATUS "Using cppunit: ${CPPUNIT_INCLUDE_DIR} ${CPPUNIT_LIBRARIES}")
	endif()
endif()

message("  Supported features")
message("-----------------------")

if(SPECTRUM_VERSION)
	add_definitions(-DSPECTRUM_VERSION="${SPECTRUM_VERSION}")
else(SPECTRUM_VERSION)
	if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
		if(NOT GIT_EXECUTABLE)
		set (GIT_EXECUTABLE git)
		endif()
		execute_process(COMMAND ${GIT_EXECUTABLE} "--git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git" rev-parse --short HEAD
						OUTPUT_VARIABLE GIT_REVISION
						OUTPUT_STRIP_TRAILING_WHITESPACE
		)
		set(SPECTRUM_VERSION 2.2.x-git-${GIT_REVISION})
		add_definitions(-DSPECTRUM_VERSION="${SPECTRUM_VERSION}")
	else(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
		set(SPECTRUM_VERSION 2.2.1)
		add_definitions(-DSPECTRUM_VERSION="${SPECTRUM_VERSION}")
	endif(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
endif(SPECTRUM_VERSION)

message("Version           : " ${SPECTRUM_VERSION})

if(SQLITE3_FOUND)
	add_definitions(-DWITH_SQLITE)
	include_directories(${SQLITE3_INCLUDE_DIR})
	message("SQLite3           : yes")
else(SQLITE3_FOUND)
	set(SQLITE3_LIBRARIES "")
	if(ENABLE_SQLITE3)
		message("SQLite3           : no (install sqlite3)")
	else(ENABLE_SQLITE3)
		message("SQLite3           : no (user disabled)")
	endif()
endif(SQLITE3_FOUND)

if(MYSQL_FOUND)
	add_definitions(-DWITH_MYSQL)
	include_directories(${MYSQL_INCLUDE_DIR})
	message("MySQL             : yes")
else(MYSQL_FOUND)
	set(MYSQL_LIBRARIES "")
	if(ENABLE_MYSQL)
		message("MySQL             : no (install mysql-devel)")
	else(ENABLE_MYSQL)
		message("MySQL             : no (user disabled)")
	endif()
endif(MYSQL_FOUND)

if(PQXX_FOUND)
	add_definitions(-DWITH_PQXX -DPQXX_HIDE_EXP_OPTIONAL)
	include_directories(${PQXX_INCLUDE_DIR})
	message("PostgreSQL        : yes")
else(PQXX_FOUND)
	set(PQXX_LIBRARY "")
	set(PQ_LIBRARY "")
	if(ENABLE_PQXX)
		message("PostgreSQL        : no (install libpqxx-devel)")
	else(ENABLE_PQXX)
		message("PostgreSQL        : no (user disabled)")
	endif()
endif(PQXX_FOUND)

if(PROTOBUF_FOUND)
	add_definitions(-DWITH_PROTOBUF)
	include_directories(${PROTOBUF_INCLUDE_DIRS})
	message("Network plugins   : yes")

	if(PURPLE_FOUND)
		message("Libpurple plugin  : yes")
		include_directories(${PURPLE_INCLUDE_DIR})
		include_directories(${GLIB2_INCLUDE_DIR})
	else()
		if(ENABLE_PURPLE)
			message("Libpurple plugin  : no (install libpurple)")
		else(ENABLE_PURPLE)
			message("Libpurple plugin  : no (user disabled)")
		endif()
	endif()

	if(HAVE_EVENT)
		add_definitions(-DWITH_LIBEVENT)
		include_directories(${EVENT_INCLUDE_DIRS})
		message("  libev eventloop : yes")
	else()
		if(ENABLE_PURPLE)
			message("  libev eventloop : no (install libev-devel)")
		endif()
	endif()

	if(IRC_FOUND)
		add_definitions(-DIRC_SHARED)
		message("IRC plugin        : yes")
		include_directories(${QT_QTNETWORK_INCLUDE_DIR})
		include_directories(${IRC_INCLUDE_DIR})
	else()
		if(ENABLE_IRC)
			message("IRC plugin        : no (install libCommuni and libprotobuf-dev)")
		else(ENABLE_IRC)
			message("IRC plugin        : no (user disabled)")
		endif()
	endif()
	if(ENABLE_TWITTER)
		message("Twitter plugin    : yes")
	else(ENABLE_TWITTER)
		message("Twitter plugin    : no (user disabled)")
	endif()
	if(NOT WIN32)
		if(ENABLE_FROTZ)
			message("Frotz plugin      : yes")
		else()
			message("Frotz plugin      : no (user disabled)")
		endif()
		if(ENABLE_SMSTOOLS3)
			message("SMSTools3 plugin  : yes")
		else()
			message("SMSTools3 plugin  : no (user disabled)")
		endif()
	else()
		message("Frotz plugin      : no (does not run on Win32)")
		message("SMSTools3 plugin  : no (does not run on Win32)")
		message("Skype plugin      : no (does not run on Win32)")
	endif()

	if(ENABLE_XMPP)
		message("Swiften plugin    : yes")
	else()
		message("Swiften plugin    : no (user disabled)")
	endif()
else()
	message("Network plugins   : no (install libprotobuf-dev)")
	message("Libpurple plugin  : no (install libpurple and libprotobuf-dev)")
	message("IRC plugin        : no (install libircclient-qt and libprotobuf-dev)")
	message("Frotz plugin      : no (install libprotobuf-dev)")
	message("SMSTools3 plugin  : no (install libprotobuf-dev)")
	message("Swiften plugin    : no (install libprotobuf-dev)")
	message("Twitter plugin    : no (install libprotobuf-dev)")
endif()

if(LOG4CXX_FOUND)
	message("Log4cxx           : yes")
	include_directories(${LOG4CXX_INCLUDE_DIR})
	add_definitions(-DWITH_LOG4CXX)
else()
	set(LOG4CXX_LIBRARIES "")
	if(WIN32)
		message("Log4cxx           : no (install log4cxx-devel)")
	else()
		message(FATAL_ERROR "Log4cxx           : no (install log4cxx-devel)")
	endif()
endif()

if(WIN32)
	add_definitions(-DLOG4CXX_STATIC)
endif()

if(CMAKE_BUILD_TYPE MATCHES Debug)
	if(CMAKE_COMPILER_IS_GNUCXX)
		add_definitions(-O0)
		add_definitions(-ggdb)
	endif()
	add_definitions(-DDEBUG)
	message("Debug             : yes")
else(CMAKE_BUILD_TYPE MATCHES Debug)
	message("Debug             : no (run \"cmake . -DCMAKE_BUILD_TYPE=Debug\")")
endif(CMAKE_BUILD_TYPE MATCHES Debug)

set(TRANSPORT_VERSION 2.0)
set(PROJECT_VERSION 2.0)
include_directories(include)

include_directories(${EVENT_INCLUDE_DIRS})
include_directories(${SWIFTEN_INCLUDE_DIR})
include_directories(${Boost_INCLUDE_DIRS})

if(CMAKE_COMPILER_IS_GNUCXX)
include_directories(${OPENSSL_INCLUDE_DIR})
endif()

add_subdirectory(libtransport)
add_subdirectory(plugin)
add_subdirectory(include)
add_subdirectory(spectrum)
add_subdirectory(backends)
add_subdirectory(tests)
if(NOT WIN32)
	add_subdirectory(spectrum_manager)
#	add_subdirectory(spectrum2_send_message)
endif()

if(CPPUNIT_FOUND)
	message("Tests             : yes")
	include_directories(${CPPUNIT_INCLUDE_DIR})
else()
	if(ENABLE_TESTS)
		message("Tests             : no (install CPPUnit)")
	else(ENABLE_TESTS)
		message("Tests             : no (user disabled)")
	endif()
endif()

if(DOXYGEN_FOUND)
	message("Documentation     : yes")
	add_subdirectory(docs)
else(DOXYGEN_FOUND)
	if(ENABLE_DOCS)
		message("Documentation     : no (install doxygen)")
	else(ENABLE_DOCS)
		message("Documentation     : no (user disabled)")
	endif()
endif(DOXYGEN_FOUND)

message("----------------------")

if(NOT SQLITE3_FOUND AND NOT MYSQL_FOUND AND NOT PQXX_FOUND)

=== backends/CMakeLists.txt ===
if(PROTOBUF_FOUND)
	add_subdirectory(template)

	if(PURPLE_FOUND)
		add_subdirectory(libpurple)
	endif()

	if(IRC_FOUND)
		add_subdirectory(libcommuni)
	endif()

	if(ENABLE_XMPP)
		add_subdirectory(swiften)
	endif()

	if(ENABLE_TWITTER)
		add_subdirectory(twitter)
	endif()

	if(NOT WIN32)
		if(ENABLE_SMSTOOLS3)
			add_subdirectory(smstools3)
		endif()
		if(ENABLE_FROTZ)
			add_subdirectory(frotz)
		endif()
	endif()
endif()

=== docs/CMakeLists.txt ===
add_subdirectory(api)

=== libtransport/CMakeLists.txt ===
file(GLOB SRC *.cpp *.h)
file(GLOB_RECURSE SWIFTEN_SRC ../include/Swiften/*.cpp)

# Build without openssl on msvc
if(NOT MSVC)
	if(APPLE)
		string(REGEX REPLACE "[^;]+;?/Schannel/[^;]+;?" "" SWIFTEN_SRC "${SWIFTEN_SRC}")
		string(REGEX REPLACE "[^;]+;?/OpenSSL/[^;]+;?" "" SWIFTEN_SRC "${SWIFTEN_SRC}")
	else()
		string(REGEX REPLACE "[^;]+;?/Schannel/[^;]+;?" "" SWIFTEN_SRC "${SWIFTEN_SRC}")
		string(REGEX REPLACE "[^;]+;?/SecureTransport/[^;]+;?" "" SWIFTEN_SRC "${SWIFTEN_SRC}") 
	endif()
else()
	string(REGEX REPLACE "[^;]+;?/OpenSSL/[^;]+;?" "" SWIFTEN_SRC "${SWIFTEN_SRC}") 
	string(REGEX REPLACE "[^;]+;?/SecureTransport/[^;]+;?" "" SWIFTEN_SRC "${SWIFTEN_SRC}")
endif()

file(GLOB HEADERS ../include/transport/*.h)
include_directories(../spectrum/src/frontends/xmpp/)

if(NOT WIN32)
	include_directories(${POPT_INCLUDE_DIR})
endif()

#source_group(headers FILES ${HEADERS})

if(PROTOBUF_FOUND)
	if(NOT WIN32)
		add_library(transport SHARED ${HEADERS} ${SRC} ${SWIFTEN_SRC})
	else()
		add_library(transport STATIC ${HEADERS} ${SRC} ${SWIFTEN_SRC})
	endif()
#	set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/../include/transport/protocol.pb.cc PROPERTIES GENERATED 1)
	add_dependencies(transport pb) 
else(PROTOBUF_FOUND)
	add_library(transport SHARED ${HEADERS} ${SRC} ${SWIFTEN_SRC})
endif(PROTOBUF_FOUND)

# if(CMAKE_COMPILER_IS_GNUCXX)
	if(NOT WIN32)
		add_definitions(-fPIC)
	endif()
# endif()

find_package(CURL)

target_link_libraries(transport transport-plugin ${CURL_LIBRARIES} ${SQLITE3_LIBRARIES} ${MYSQL_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES} ${POPT_LIBRARY} ${PROTOBUF_LIBRARY} JsonCpp::JsonCpp)

if(WIN32)
	target_link_libraries(transport psapi.lib bcrypt.lib)
endif()

if(PQXX_FOUND)
	target_link_libraries(transport	${PQXX_LIBRARIES} ${PQ_LIBRARY})
endif()

set_target_properties(transport PROPERTIES
	VERSION ${TRANSPORT_VERSION} SOVERSION ${TRANSPORT_VERSION}
)
if(APPLE)
	target_link_libraries(transport ${APPLE_FRAMEWORKS})
endif()

install(TARGETS transport LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries)

#configure_file(transport.pc.in "${CMAKE_CURRENT_BINARY_DIR}/transport.pc")
#install(FILES "${CMAKE_CURRENT_BINARY_DIR}/transport.pc" DESTINATION lib/pkgconfig)

=== plugin/CMakeLists.txt ===
add_subdirectory(cpp)
add_subdirectory(python)

=== tests/CMakeLists.txt ===
add_subdirectory(libtransport)

if(ENABLE_TESTS)

  add_custom_target(test
    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/libtransport/libtransport_test
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests_output
  )

  add_custom_target(extended_test
    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/libtransport/libtransport_test
    COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/start.py
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests_output
  )

endif()

=== backends/libcommuni/CMakeLists.txt ===
file(GLOB SRC *.cpp)
file(GLOB HEADERS *.h)

if(ENABLE_QT4)
	QT4_WRAP_CPP(SRC ${HEADERS} OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)
else()
	QT5_WRAP_CPP(SRC ${HEADERS} OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)
	include_directories(${Qt5Core_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS})
endif()

add_definitions(-DQT_NO_KEYWORDS)
add_executable(spectrum2_libcommuni_backend ${SRC})

if(NOT WIN32)
	if(ENABLE_QT4)
		target_link_libraries(spectrum2_libcommuni_backend ${IRC_LIBRARY} Qt4::QtNetwork Qt4::QtCore transport pthread)
	else()
		target_link_libraries(spectrum2_libcommuni_backend ${IRC_LIBRARY} Qt5::Network Qt5::Core transport pthread)
	endif()
else()
	if(ENABLE_QT4)
		target_link_libraries(spectrum2_libcommuni_backend ${IRC_LIBRARY} Qt4::QtNetwork Qt4::QtCore transport)
	else()
		target_link_libraries(spectrum2_libcommuni_backend ${IRC_LIBRARY} Qt5::Network Qt5::Core transport)
	endif()
endif()

install(TARGETS spectrum2_libcommuni_backend RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

=== backends/libpurple/CMakeLists.txt ===
file(GLOB SRC *.cpp)

add_executable(spectrum2_libpurple_backend ${SRC})

target_link_libraries(spectrum2_libpurple_backend transport-plugin ${PURPLE_LIBRARY} ${GLIB2_LIBRARIES} ${EVENT_LIBRARIES})

install(TARGETS spectrum2_libpurple_backend RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

=== backends/smstools3/CMakeLists.txt ===
file(GLOB SRC *.c *.cpp)

add_executable(spectrum2_smstools3_backend ${SRC})

target_link_libraries(spectrum2_smstools3_backend transport pthread ${Boost_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES})

install(TARGETS spectrum2_smstools3_backend RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

=== backends/swiften/CMakeLists.txt ===
file(GLOB SRC *.cpp)

add_executable(spectrum2_swiften_backend ${SRC})

if(NOT WIN32)
	target_link_libraries(spectrum2_swiften_backend transport pthread ${Boost_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES})
else()
	target_link_libraries(spectrum2_swiften_backend transport ${Boost_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES})
endif()

install(TARGETS spectrum2_swiften_backend RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

=== backends/template/CMakeLists.txt ===
file(GLOB SRC *.c *.cpp)

add_executable(spectrum2_template_backend ${SRC})

if(CMAKE_COMPILER_IS_GNUCXX)
	if(NOT WIN32)
		target_link_libraries(spectrum2_template_backend transport pthread ${Boost_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES})
	else()
		target_link_libraries(spectrum2_template_backend transport ${Boost_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES})
	endif()
else()
	target_link_libraries(spectrum2_template_backend transport ${Boost_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES})
endif()

#install(TARGETS spectrum2_template_backend RUNTIME DESTINATION bin)

=== backends/twitter/CMakeLists.txt ===
include_directories(${libtransport_SOURCE_DIR}/backends/twitter/libtwitcurl)

file(GLOB SRC *.cpp libtwitcurl/*.cpp Requests/*.cpp)

add_executable(spectrum2_twitter_backend ${SRC})

find_package(CURL)

if(CURL_FOUND)
	message(STATUS "Using curl ${CURL_VERSION_STRING}: ${CURL_INCLUDE_DIRS} ${CURL_LIBRARIES}")
	target_link_libraries(spectrum2_twitter_backend transport JsonCpp::JsonCpp ${CURL_LIBRARIES} ${Boost_LIBRARIES} ${SWIFTEN_LIBRARY} ${LOG4CXX_LIBRARIES})
else()
	message(FATAL_ERROR "curl not found")
endif()

install(TARGETS spectrum2_twitter_backend RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

=== debian/changelog ===
spectrum2 (2.2.1+dfsg-2) unstable; urgency=medium

  * Apply wrap-and-sort.
  * Mark libtransport-plugin2.0 as Multiarch: same
  * B-D on libevent-dev, fixes 32bit archs.

 -- Tobias Frost <tobi@debian.org>  Sat, 10 Aug 2024 16:37:44 +0200

spectrum2 (2.2.1+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #672699)
  * Package is based on prior work from Thorsten Glaser and Dominik George.

 -- Tobias Frost <tobi@debian.org>  Tue, 23 Jul 2024 11:14:46 +0200

=== debian/control ===
Source: spectrum2
Section: net
Priority: optional
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Tobias Frost <tobi@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               default-libmysqlclient-dev,
               doxygen,
               libavahi-client-dev,
               libavahi-common-dev,
               libboost-all-dev,
               libcommuni-dev,
               libcppunit-dev,
               libcurl4-gnutls-dev,
               libdbus-glib-1-dev,
               libev-dev,
               libevent-dev,
               libidn-dev,
               libjsoncpp-dev,
               liblog4cxx-dev,
               libminiupnpc-dev,
               libnatpmp-dev,
               libpopt-dev,
               libpqxx-dev,
               libprotobuf-dev,
               libpurple-dev,
               libsqlite3-dev,
               libswiften-dev,
               libxml2-dev,
               protobuf-compiler,
               qtbase5-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/xmpp-team/spectrum2.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/spectrum2
Homepage: https://spectrum.im/

Package: spectrum2
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: spectrum2-webinterface
Description: Spectrum 2 - XMPP transport framework
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains the Spectrum 2 framework and manager.

# The webinterface cannot be packaged due to licensing issues
# (mongoose is not compatible with spectrum license)
#Package: spectrum2-webinterface
#Architecture: all
#Depends:
# libjs-jquery,
# libjs-jquery-ui,
# libjs-jquery-cookie,
# libjs-bootstrap,
# libjs-bootbox,
# spectrum2 (>= ${source:Version}), spectrum2 (<< ${source:Version}.1~),
#  ${misc:Depends},
#Description: Spectrum 2 - XMPP transport framework web interface
# Spectrum 2 is a set of and framework for instant messaging transports,
# mainly Jabber/XMPP. It can be used to make foreign networks, like
# ICQ, MSN, Twitter, or protocols that libpurple supports, available
# through an XMPP server.
# .
# This package contains the Spectrum 2 web interface files and systemd file to
# start the web interface automatically.

Package: libtransport2.0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Spectrum 2 - XMPP transport library
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains the XMPP transport library.

Package: libtransport-plugin2.0
Section: libs
Multi-Arch: same
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Spectrum 2 - XMPP transport library plugin development
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains the basis for developing plugins.

Package: libtransport-dev
Section: libdevel
Architecture: any
Depends: libtransport-plugin2.0 (= ${binary:Version}),
         libtransport2.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Spectrum 2 - XMPP transport library (development headers)
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains development headers for the XMPP transport library.

Package: spectrum2-backend-libpurple
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Spectrum 2 - libpurple backend
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains the backend to connect to protocols through libpurple.

Package: spectrum2-backend-swiften
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Spectrum 2 - SWIFT backend
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains the backend to connect to XMPP through SWIFT.

Package: spectrum2-backend-smstools3
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Spectrum 2 - smstools3 backend
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains the backend to send and receive SMS through smstools3.

Package: spectrum2-backend-libcommuni
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Spectrum 2 - libcommuni (IRC) backend
 Spectrum 2 is a set of and framework for instant messaging transports,
 mainly Jabber/XMPP. It can be used to make foreign networks, like
 ICQ, MSN, Twitter, or protocols that libpurple supports, available
 through an XMPP server.
 .
 This package contains the backend to connect to IRC through libcommuni.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL

OUR_CPPFLAGS:=
OUR_CFLAGS:=
OUR_CXXFLAGS:=
OUR_LDFLAGS:=

# added by CMakeLists.txt for (CMAKE_BUILD_TYPE MATCHES Debug)
OUR_CPPFLAGS+=	-DDEBUG

dpkgbuildflagsmkescape=$(subst \,\\\,$(1))
export DEB_BUILD_MAINT_OPTIONS:=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CPPFLAGS})
export DEB_CFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CFLAGS})
export DEB_CXXFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CXXFLAGS})
export DEB_LDFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_LDFLAGS})
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

CMAKE_DEFS:=	-DSPECTRUM_VERSION="${DEB_VERSION_UPSTREAM}"
CMAKE_DEFS+=	-DENABLE_QT4=OFF
# Tests are FTBFS -- TODO to fix that.
CMAKE_DEFS+=	-DENABLE_TESTS=OFF
# Frotz is removed due to license concerns.
CMAKE_DEFS+=	-DENABLE_FROTZ=OFF
CMAKE_DEFS+=	-DCMAKE_VERBOSE_MAKEFILE=On
# incompatible license. (uses mongoose, which is incompatible with some parts of the remaining source.)
CMAKE_DEFS+=	-DENABLE_WEBUI=Off
# twitter plugin is defunct
CMAKE_DEFS+=	-DENABLE_TWITTER=Off

override_dh_auto_configure:
	exec dh_auto_configure -- ${CMAKE_DEFS}

execute_after_dh_auto_install:
	mkdir -p debian/tmp/usr/share debian/tmp/var/lib/spectrum2

=== debian/watch ===
version=4
opts=repack,dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/spectrum2-$1\.tar\.gz/ \
  https://github.com/SpectrumIM/spectrum2/tags .*/v?(\d\S+)\.tar\.gz
